Index: sansmodels/src/c_extensions/DiamCyl.h
===================================================================
--- sansmodels/src/c_extensions/DiamCyl.h	(revision 67424cdc019bde2f4cbc089828ff660e6f914c2c)
+++ sansmodels/src/c_extensions/DiamCyl.h	(revision 0ba3b08c35684feff124c0657dad569d13717a18)
@@ -1,4 +1,5 @@
 #if !defined(DiamCyl_h)
 #define DiamCyl_h
+#include "parameters.hh"
 
 /**
@@ -16,23 +17,23 @@
 **/
 
-typedef struct {
-    ///	Radius [A]
-    //  [DEFAULT]=radius=20.0 A
-    double radius;
+class DiamCylFunc{
+public:
+  // Model parameters
+  /// Radius [A]
+  //  [DEFAULT]=radius=20.0 A
+  Parameter radius;
+  /// Length [A]
+  //  [DEFAULT]=length= 400 A
+  Parameter length;
 
-    /// Length [A]
-    //  [DEFAULT]=length= 400 A
-    double length;
+  // Constructor
+  DiamCylFunc();
 
-} DiamCyldParameters;
-
-
-
-/// 1D scattering function
-//double DiamCyld_analytical_1D(DiamCyldParameters *pars, double q);
-
-/// 2D scattering function
-//double DiamCyld_analytical_2D(DiamCyldParameters *pars, double q, double phi);
-//double DiamCyld_analytical_2DXY(DiamCyldParameters *pars, double qx, double qy);
+  // Operators to get I(Q)
+  double operator()(double q);
+  double operator()(double qx, double qy);
+  double calculate_ER();
+  double evaluate_rphi(double q, double phi);
+};
 
 #endif
Index: sansmodels/src/c_extensions/DiamEllip.h
===================================================================
--- sansmodels/src/c_extensions/DiamEllip.h	(revision 67424cdc019bde2f4cbc089828ff660e6f914c2c)
+++ sansmodels/src/c_extensions/DiamEllip.h	(revision 0ba3b08c35684feff124c0657dad569d13717a18)
@@ -1,4 +1,5 @@
 #if !defined(DiamEllip_h)
 #define DiamEllip_h
+#include "parameters.hh"
 
 /**
@@ -20,23 +21,25 @@
 
  **/
-typedef struct {
-    ///	Polar radius [A]
-    //  [DEFAULT]=radius_a=20.0 A
-    double radius_a;
 
-    /// Equatorial radius [A]
-    //  [DEFAULT]=radius_b= 400 A
-    double radius_b;
+class DiamEllipFunc{
+public:
+  // Model parameters
+  /// Polar radius [A]
+  //  [DEFAULT]=radius_a=20.0 A
+  Parameter radius_a;
 
-} DiamEllipsParameters;
+  /// Equatorial radius [A]
+  //  [DEFAULT]=radius_b= 400 A
+  Parameter radius_b;
 
+  // Constructor
+  DiamEllipFunc();
 
-
-/// 1D scattering function
-//double DiamEllips_analytical_1D(DiamEllipsParameters *pars, double q);
-
-/// 2D scattering function
-//double DiamEllips_analytical_2D(DiamEllipsParameters *pars, double q, double phi);
-//double DiamEllips_analytical_2DXY(DiamEllipsParameters *pars, double qx, double qy);
+  // Operators to get I(Q)
+  double operator()(double q);
+  double operator()(double qx, double qy);
+  double calculate_ER();
+  double evaluate_rphi(double q, double phi);
+};
 
 #endif
Index: sansmodels/src/c_extensions/Hardsphere.h
===================================================================
--- sansmodels/src/c_extensions/Hardsphere.h	(revision 67424cdc019bde2f4cbc089828ff660e6f914c2c)
+++ sansmodels/src/c_extensions/Hardsphere.h	(revision 0ba3b08c35684feff124c0657dad569d13717a18)
@@ -1,44 +1,46 @@
 #if !defined(Hardsphere_h)
 #define Hardsphere_h
+#include "parameters.hh"
 
 /**
  * Structure definition for HardsphereStructure (factor) parameters
  */
- //[PYTHONCLASS] = HardsphereStructure
- //[DISP_PARAMS] = effect_radius
- //[DESCRIPTION] =<text>Structure factor for interacting particles:                   .
- //
- //  The interparticle potential is
- //
- //                     U(r)= inf   , r < 2R
- //                         = 0     , r >= 2R
- //
- //						R: effective radius of the Hardsphere particle
- //						V:The volume fraction
- //
- //    Ref: Percus., J. K.,etc., J. Phy.
- //     Rev. 1958, 110, 1.
- //	 </text>
- //[FIXED]= effect_radius.width
+//[PYTHONCLASS] = HardsphereStructure
+//[DISP_PARAMS] = effect_radius
+//[DESCRIPTION] =<text>Structure factor for interacting particles:                   .
+//
+//  The interparticle potential is
+//
+//                     U(r)= inf   , r < 2R
+//                         = 0     , r >= 2R
+//
+//						R: effective radius of the Hardsphere particle
+//						V:The volume fraction
+//
+//    Ref: Percus., J. K.,etc., J. Phy.
+//     Rev. 1958, 110, 1.
+//	 </text>
+//[FIXED]= effect_radius.width
 
+class HardsphereStructure{
+public:
+  // Model parameters
+  /// effect radius of hardsphere [A]
+  //  [DEFAULT]=effect_radius=50.0 [A]
+  Parameter effect_radius;
 
-typedef struct {
-    /// effect radius of hardsphere [A]
-    //  [DEFAULT]=effect_radius=50.0 [A]
-    double effect_radius;
+  /// Volume fraction
+  //  [DEFAULT]=volfraction= 0.2
+  Parameter volfraction;
 
-    ///	Volume fraction
-    //  [DEFAULT]=volfraction= 0.2
-    double volfraction;
-} HardsphereParameters;
+  // Constructor
+  HardsphereStructure();
 
-
-
-/// 1D scattering function
-//double Hardsphere_analytical_1D(HardsphereParameters *pars, double q);
-
-/// 2D scattering function
-//double Hardsphere_analytical_2D(HardsphereParameters *pars, double q, double phi);
-//double Hardsphere_analytical_2DXY(HardsphereParameters *pars, double qx, double qy);
+  // Operators to get I(Q)
+  double operator()(double q);
+  double operator()(double qx, double qy);
+  double calculate_ER();
+  double evaluate_rphi(double q, double phi);
+};
 
 #endif
Index: sansmodels/src/c_extensions/HayterMSA.h
===================================================================
--- sansmodels/src/c_extensions/HayterMSA.h	(revision 67424cdc019bde2f4cbc089828ff660e6f914c2c)
+++ sansmodels/src/c_extensions/HayterMSA.h	(revision 0ba3b08c35684feff124c0657dad569d13717a18)
@@ -1,59 +1,64 @@
 #if !defined(HayterMSA_h)
 #define HayterMSA_h
+#include "parameters.hh"
 
 /**
  * Structure definition for screened Coulomb interaction
  */
- //[PYTHONCLASS] = HayterMSAStructure
- //[DISP_PARAMS] = effect_radius
- //[DESCRIPTION] =<text>To calculate the structure factor (the Fourier transform of the
- //                     pair correlation function g(r)) for a system of
- //                     charged, spheroidal objects in a dielectric
- //						medium.
- //                     When combined with an appropriate form
- //                     factor, this allows for inclusion of
- //                     the interparticle interference effects
- //                     due to screened coulomb repulsion between
- //                     charged particles.
- //						(Note: charge > 0 required.)
- //
- //                     Ref: JP Hansen and JB Hayter, Molecular
- //                           Physics 46, 651-656 (1982).
- //
- //				</text>
- //[FIXED]= effect_radius.width
+//[PYTHONCLASS] = HayterMSAStructure
+//[DISP_PARAMS] = effect_radius
+//[DESCRIPTION] =<text>To calculate the structure factor (the Fourier transform of the
+//                     pair correlation function g(r)) for a system of
+//                     charged, spheroidal objects in a dielectric
+//						medium.
+//                     When combined with an appropriate form
+//                     factor, this allows for inclusion of
+//                     the interparticle interference effects
+//                     due to screened coulomb repulsion between
+//                     charged particles.
+//						(Note: charge > 0 required.)
+//
+//                     Ref: JP Hansen and JB Hayter, Molecular
+//                           Physics 46, 651-656 (1982).
+//
+//				</text>
+//[FIXED]= effect_radius.width
 
-typedef struct {
-    ///	effetitve radius of particle [A]
-    //  [DEFAULT]=effect_radius=20.75 [A]
-    double effect_radius;
+class HayterMSAStructure{
+public:
+  // Model parameters
+  /// effetitve radius of particle [A]
+  //  [DEFAULT]=effect_radius=20.75 [A]
+  Parameter effect_radius;
 
-    /// charge
-    //  [DEFAULT]=charge= 19
-    double charge;
+  /// charge
+  //  [DEFAULT]=charge= 19
+  Parameter charge;
 
-    /// Volume fraction
-    //  [DEFAULT]=volfraction= 0.0192
-    double volfraction;
+  /// Volume fraction
+  //  [DEFAULT]=volfraction= 0.0192
+  Parameter volfraction;
 
-	///	Temperature [K]
-    //  [DEFAULT]=temperature= 318.16 [K]
-    double temperature;
+  /// Temperature [K]
+  //  [DEFAULT]=temperature= 318.16 [K]
+  Parameter temperature;
 
-	///	Monovalent salt concentration [M]
-    //  [DEFAULT]=saltconc= 0 [M]
-    double saltconc;
+  /// Monovalent salt concentration [M]
+  //  [DEFAULT]=saltconc= 0 [M]
+  Parameter saltconc;
 
-    ///	Dielectric constant of solvent
-    //  [DEFAULT]=dielectconst= 71.08
-    double dielectconst;
-} HayterMSAParameters;
+  /// Dielectric constant of solvent
+  //  [DEFAULT]=dielectconst= 71.08
+  Parameter dielectconst;
 
-/// 1D scattering function
-//double HayterMSA_analytical_1D(HayterMSAParameters *pars, double q);
+  // Constructor
+  HayterMSAStructure();
 
-/// 2D scattering function
-//double HayterMSA_analytical_2D(HayterMSAParameters *pars, double q, double phi);
-//double HayterMSA_analytical_2DXY(HayterMSAParameters *pars, double qx, double qy);
+  // Operators to get I(Q)
+  double operator()(double q);
+  double operator()(double qx, double qy);
+  double calculate_ER();
+  double evaluate_rphi(double q, double phi);
+};
 
 #endif
Index: sansmodels/src/c_extensions/SquareWell.h
===================================================================
--- sansmodels/src/c_extensions/SquareWell.h	(revision 67424cdc019bde2f4cbc089828ff660e6f914c2c)
+++ sansmodels/src/c_extensions/SquareWell.h	(revision 0ba3b08c35684feff124c0657dad569d13717a18)
@@ -1,7 +1,8 @@
 #if !defined(SquareWell_h)
 #define SquareWell_h
+#include "parameters.hh"
 
 /**Structure definition for SquareWell parameters
-*/
+ */
 //   [PYTHONCLASS] = SquareWellStructure
 //   [DISP_PARAMS] = effect_radius
@@ -26,32 +27,32 @@
 //[ORIENTATION_PARAMS]= <text> </text>
 
+class SquareWellStructure{
+public:
+  // Model parameters
+  /// effective radius of particle [A]
+  //  [DEFAULT]=effect_radius=50.0 [A]
+  Parameter effect_radius;
 
-typedef struct {
-    ///	effective radius of particle [A]
-    //  [DEFAULT]=effect_radius=50.0 [A]
-    double effect_radius;
+  /// Volume fraction
+  //  [DEFAULT]=volfraction= 0.040
+  Parameter volfraction;
 
-    /// Volume fraction
-    //  [DEFAULT]=volfraction= 0.040
-    double volfraction;
+  /// Well depth [kT]
+  //  [DEFAULT]=welldepth= 1.50 [kT]
+  Parameter welldepth;
 
-    ///	Well depth [kT]
-    //  [DEFAULT]=welldepth= 1.50 [kT]
-    double welldepth;
+  /// Well width
+  //  [DEFAULT]=wellwidth= 1.20
+  Parameter wellwidth;
 
-    ///	Well width
-    //  [DEFAULT]=wellwidth= 1.20
-    double wellwidth;
+  // Constructor
+  SquareWellStructure();
 
-} SquareWellParameters;
-
-
-
-/// 1D scattering function
-//double SquareWell_analytical_1D(SquareWellParameters *pars, double q);
-
-/// 2D scattering function
-//double SquareWell_analytical_2D(SquareWellParameters *pars, double q, double phi);
-//double SquareWell_analytical_2DXY(SquareWellParameters *pars, double qx, double qy);
+  // Operators to get I(Q)
+  double operator()(double q);
+  double operator()(double qx, double qy);
+  double calculate_ER();
+  double evaluate_rphi(double q, double phi);
+};
 
 #endif
Index: sansmodels/src/c_extensions/StickyHS.h
===================================================================
--- sansmodels/src/c_extensions/StickyHS.h	(revision 67424cdc019bde2f4cbc089828ff660e6f914c2c)
+++ sansmodels/src/c_extensions/StickyHS.h	(revision 0ba3b08c35684feff124c0657dad569d13717a18)
@@ -1,54 +1,58 @@
 #if !defined(StickyHS_h)
 #define StickyHS_h
+#include "parameters.hh"
 
 /**
  * Structure definition for StickyHS_struct (struncture factor) parameters
  */
- //[PYTHONCLASS] = StickyHSStructure
- //[DISP_PARAMS] = effect_radius
- //[DESCRIPTION] =<text> Structure Factor for interacting particles:                               .
- //
- //  The interaction potential is
- //
- //                     U(r)= inf , r < 2R
- //                         = -Uo  , 2R < r < 2R + w
- //                         = 0   , r >= 2R +w
- //
- //						R: effective radius of the hardsphere
- //                     stickiness = [exp(Uo/kT)]/(12*perturb)
- //                     perturb = w/(w+ 2R) , 0.01 =< w <= 0.1
- //                     w: The width of the square well ,w > 0
- //						v: The volume fraction , v > 0
- //
- //                     Ref: Menon, S. V. G.,et.al., J. Chem.
- //                      Phys., 1991, 95(12), 9186-9190.
- //				</text>
- //[FIXED]= effect_radius.width
-typedef struct {
-    /// effect radius of hardsphere [A]
-    //  [DEFAULT]=effect_radius=50.0 [A]
-    double effect_radius;
+//[PYTHONCLASS] = StickyHSStructure
+//[DISP_PARAMS] = effect_radius
+//[DESCRIPTION] =<text> Structure Factor for interacting particles:                               .
+//
+//  The interaction potential is
+//
+//                     U(r)= inf , r < 2R
+//                         = -Uo  , 2R < r < 2R + w
+//                         = 0   , r >= 2R +w
+//
+//						R: effective radius of the hardsphere
+//                     stickiness = [exp(Uo/kT)]/(12*perturb)
+//                     perturb = w/(w+ 2R) , 0.01 =< w <= 0.1
+//                     w: The width of the square well ,w > 0
+//						v: The volume fraction , v > 0
+//
+//                     Ref: Menon, S. V. G.,et.al., J. Chem.
+//                      Phys., 1991, 95(12), 9186-9190.
+//				</text>
+//[FIXED]= effect_radius.width
 
-    ///	Volume fraction
-    //  [DEFAULT]=volfraction= 0.1
-    double volfraction;
+class StickyHSStructure{
+public:
+  // Model parameters
+  /// effect radius of hardsphere [A]
+  //  [DEFAULT]=effect_radius=50.0 [A]
+  Parameter effect_radius;
 
-	/// Perturbation Parameter ( between 0.01 - 0.1)
-    //  [DEFAULT]=perturb=0.05
-    double perturb;
+  /// Volume fraction
+  //  [DEFAULT]=volfraction= 0.1
+  Parameter volfraction;
 
-    ///	Stickiness
-    //  [DEFAULT]=stickiness= 0.2
-    double stickiness;
-} StickyHSParameters;
+  /// Perturbation Parameter ( between 0.01 - 0.1)
+  //  [DEFAULT]=perturb=0.05
+  Parameter perturb;
 
+  /// Stickiness
+  //  [DEFAULT]=stickiness= 0.2
+  Parameter stickiness;
 
+  // Constructor
+  StickyHSStructure();
 
-/// 1D scattering function
-//double StickyHS_analytical_1D(StickyHSParameters *pars, double q);
-
-/// 2D scattering function
-//double StickyHS_analytical_2D(StickyHSParameters *pars, double q, double phi);
-//double StickyHS_analytical_2DXY(StickyHSParameters *pars, double qx, double qy);
+  // Operators to get I(Q)
+  double operator()(double q);
+  double operator()(double qx, double qy);
+  double calculate_ER();
+  double evaluate_rphi(double q, double phi);
+};
 
 #endif
Index: sansmodels/src/c_extensions/bcc.h
===================================================================
--- sansmodels/src/c_extensions/bcc.h	(revision 67424cdc019bde2f4cbc089828ff660e6f914c2c)
+++ sansmodels/src/c_extensions/bcc.h	(revision 0ba3b08c35684feff124c0657dad569d13717a18)
@@ -1,81 +1,83 @@
 #if !defined(bcc_h)
 #define bcc_h
+#include "parameters.hh"
 
 /**
  * Structure definition for BCC_ParaCrystal parameters
  */
- //[PYTHONCLASS] = BCCrystalModel
- //[DISP_PARAMS] = radius,phi, psi, theta
- //[DESCRIPTION] =<text>P(q)=(scale/Vp)*V_lattice*P(q)*Z(q)+bkg where scale is the volume
- //					 fraction of sphere,
- //				Vp = volume of the primary particle,
- //				V_lattice = volume correction for
- //					for the crystal structure,
- //				P(q)= form factor of the sphere (normalized),
- //				Z(q)= paracrystalline structure factor
- //					for a face centered cubic structure.
- //				[Body Centered Cubic ParaCrystal Model]
- //				Parameters;
- //				scale: volume fraction of spheres
- //				bkg:background, R: radius of sphere
- //				dnn: Nearest neighbor distance
- //				d_factor: Paracrystal distortion factor
- //				radius: radius of the spheres
- //				sldSph: SLD of the sphere
- //				sldSolv: SLD of the solvent
- //
- //		</text>
- //[FIXED]=  radius.width;phi.width;psi.width; theta.width
- //[ORIENTATION_PARAMS]= <text> phi;psi; theta; phi.width;psi.width; theta.width</text>
+//[PYTHONCLASS] = BCCrystalModel
+//[DISP_PARAMS] = radius,phi, psi, theta
+//[DESCRIPTION] =<text>P(q)=(scale/Vp)*V_lattice*P(q)*Z(q)+bkg where scale is the volume
+//					 fraction of sphere,
+//				Vp = volume of the primary particle,
+//				V_lattice = volume correction for
+//					for the crystal structure,
+//				P(q)= form factor of the sphere (normalized),
+//				Z(q)= paracrystalline structure factor
+//					for a face centered cubic structure.
+//				[Body Centered Cubic ParaCrystal Model]
+//				Parameters;
+//				scale: volume fraction of spheres
+//				bkg:background, R: radius of sphere
+//				dnn: Nearest neighbor distance
+//				d_factor: Paracrystal distortion factor
+//				radius: radius of the spheres
+//				sldSph: SLD of the sphere
+//				sldSolv: SLD of the solvent
+//
+//		</text>
+//[FIXED]=  radius.width;phi.width;psi.width; theta.width
+//[ORIENTATION_PARAMS]= <text> phi;psi; theta; phi.width;psi.width; theta.width</text>
 
-typedef struct {
-    /// Scale factor
-    //  [DEFAULT]=scale= 1.0
-    double scale;
+class BCCrystalModel{
+public:
+  // Model parameters
+  /// Scale factor
+  //  [DEFAULT]=scale= 1.0
+  Parameter scale;
 
-    ///	Nearest neighbor distance [A]
-    //  [DEFAULT]=dnn=220.0 [A]
-    double dnn;
+  /// Nearest neighbor distance [A]
+  //  [DEFAULT]=dnn=220.0 [A]
+  Parameter dnn;
 
-    ///	Paracrystal distortion factor g
-    //  [DEFAULT]=d_factor=0.06
-    double d_factor;
+  /// Paracrystal distortion factor g
+  //  [DEFAULT]=d_factor=0.06
+  Parameter d_factor;
 
-    ///	Radius of sphere [A]
-    //  [DEFAULT]=radius=40.0 [A]
-    double radius;
+  /// Radius of sphere [A]
+  //  [DEFAULT]=radius=40.0 [A]
+  Parameter radius;
 
-    ///	sldSph [1/A^(2)]
-    //  [DEFAULT]=sldSph= 3.0e-6 [1/A^(2)]
-    double sldSph;
+  /// sldSph [1/A^(2)]
+  //  [DEFAULT]=sldSph= 3.0e-6 [1/A^(2)]
+  Parameter sldSph;
 
-    ///	sldSolv [1/A^(2)]
-    //  [DEFAULT]=sldSolv= 6.3e-6 [1/A^(2)]
-    double sldSolv;
+  /// sldSolv [1/A^(2)]
+  //  [DEFAULT]=sldSolv= 6.3e-6 [1/A^(2)]
+  Parameter sldSolv;
 
-	/// Incoherent Background [1/cm]
-	//  [DEFAULT]=background=0 [1/cm]
-	double background;
-    /// Orientation of the a1 axis w/respect incoming beam [deg]
-    //  [DEFAULT]=theta=0.0 [deg]
-    double theta;
-    /// Orientation of the a2 in the plane of the detector [deg]
-    //  [DEFAULT]=phi=0.0 [deg]
-    double phi;
-    /// Orientation of the a3 in the plane of the detector [deg]
-    //  [DEFAULT]=psi=0.0 [deg]
-    double psi;
+  /// Incoherent Background [1/cm]
+  //  [DEFAULT]=background=0 [1/cm]
+  Parameter background;
+  /// Orientation of the a1 axis w/respect incoming beam [deg]
+  //  [DEFAULT]=theta=0.0 [deg]
+  Parameter theta;
+  /// Orientation of the a2 in the plane of the detector [deg]
+  //  [DEFAULT]=phi=0.0 [deg]
+  Parameter phi;
+  /// Orientation of the a3 in the plane of the detector [deg]
+  //  [DEFAULT]=psi=0.0 [deg]
+  Parameter psi;
 
-} BCParameters;
+  // Constructor
+  BCCrystalModel();
+
+  // Operators to get I(Q)
+  double operator()(double q);
+  double operator()(double qx, double qy);
+  double calculate_ER();
+  double evaluate_rphi(double q, double phi);
+};
 
 
-
-/// 1D scattering function
-double bc_analytical_1D(BCParameters *pars, double q);
-
-/// 2D scattering function
-double bc_analytical_2D(BCParameters *pars, double q, double phi);
-double bc_analytical_2DXY(BCParameters *pars, double qx, double qy);
-double bc_analytical_2D_scaled(BCParameters *pars, double q, double q_x, double q_y);
-
 #endif
Index: sansmodels/src/c_extensions/fcc.h
===================================================================
--- sansmodels/src/c_extensions/fcc.h	(revision 67424cdc019bde2f4cbc089828ff660e6f914c2c)
+++ sansmodels/src/c_extensions/fcc.h	(revision 0ba3b08c35684feff124c0657dad569d13717a18)
@@ -1,4 +1,5 @@
 #if !defined(fcc_h)
 #define fcc_h
+#include "parameters.hh"
 
 /**
@@ -29,53 +30,53 @@
  //[ORIENTATION_PARAMS]= <text> phi;psi; theta; phi.width;psi.width; theta.width</text>
 
-typedef struct {
-    /// Scale factor
-    //  [DEFAULT]=scale= 1.0
-    double scale;
+class FCCrystalModel{
+public:
+  // Model parameters
+  /// Scale factor
+  //  [DEFAULT]=scale= 1.0
+  Parameter scale;
 
-    ///	Nearest neighbor distance [A]
-    //  [DEFAULT]=dnn=220.0 [A]
-    double dnn;
+  /// Nearest neighbor distance [A]
+  //  [DEFAULT]=dnn=220.0 [A]
+  Parameter dnn;
 
-    ///	Paracrystal distortion factor g
-    //  [DEFAULT]=d_factor=0.06
-    double d_factor;
+  /// Paracrystal distortion factor g
+  //  [DEFAULT]=d_factor=0.06
+  Parameter d_factor;
 
-    ///	Radius of sphere [A]
-    //  [DEFAULT]=radius=40.0 [A]
-    double radius;
+  /// Radius of sphere [A]
+  //  [DEFAULT]=radius=40.0 [A]
+  Parameter radius;
 
-    ///	sldSph [1/A^(2)]
-    //  [DEFAULT]=sldSph= 3.0e-6 [1/A^(2)]
-    double sldSph;
+  /// sldSph [1/A^(2)]
+  //  [DEFAULT]=sldSph= 3.0e-6 [1/A^(2)]
+  Parameter sldSph;
 
-    ///	sldSolv [1/A^(2)]
-    //  [DEFAULT]=sldSolv= 6.3e-6 [1/A^(2)]
-    double sldSolv;
+  /// sldSolv [1/A^(2)]
+  //  [DEFAULT]=sldSolv= 6.3e-6 [1/A^(2)]
+  Parameter sldSolv;
 
-	/// Incoherent Background [1/cm]
-	//  [DEFAULT]=background=0 [1/cm]
-	double background;
-    /// Orientation of the a1 axis w/respect incoming beam [deg]
-    //  [DEFAULT]=theta=0.0 [deg]
-    double theta;
-    /// Orientation of the a2 in the plane of the detector [deg]
-    //  [DEFAULT]=phi=0.0 [deg]
-    double phi;
-    /// Orientation of the a3 in the plane of the detector [deg]
-    //  [DEFAULT]=psi=0.0 [deg]
-    double psi;
+/// Incoherent Background [1/cm]
+//  [DEFAULT]=background=0 [1/cm]
+Parameter background;
+  /// Orientation of the a1 axis w/respect incoming beam [deg]
+  //  [DEFAULT]=theta=0.0 [deg]
+  Parameter theta;
+  /// Orientation of the a2 in the plane of the detector [deg]
+  //  [DEFAULT]=phi=0.0 [deg]
+  Parameter phi;
+  /// Orientation of the a3 in the plane of the detector [deg]
+  //  [DEFAULT]=psi=0.0 [deg]
+  Parameter psi;
 
-} FCParameters;
+  // Constructor
+  FCCrystalModel();
 
-
-
-/// 1D scattering function
-double fc_analytical_1D(FCParameters *pars, double q);
-
-/// 2D scattering function
-double fc_analytical_2D(FCParameters *pars, double q, double phi);
-double fc_analytical_2DXY(FCParameters *pars, double qx, double qy);
-double fc_analytical_2D_scaled(FCParameters *pars, double q, double q_x, double q_y);
+  // Operators to get I(Q)
+  double operator()(double q);
+  double operator()(double qx, double qy);
+  double calculate_ER();
+  double evaluate_rphi(double q, double phi);
+};
 
 #endif
Index: sansmodels/src/c_extensions/fuzzysphere.h
===================================================================
--- sansmodels/src/c_extensions/fuzzysphere.h	(revision 67424cdc019bde2f4cbc089828ff660e6f914c2c)
+++ sansmodels/src/c_extensions/fuzzysphere.h	(revision 0ba3b08c35684feff124c0657dad569d13717a18)
@@ -1,59 +1,61 @@
 #if !defined(fuzzysphere_h)
 #define fuzzysphere_h
+#include "parameters.hh"
 
 /**
  * Structure definition for FuzzySphere parameters
  */
- //[PYTHONCLASS] = FuzzySphereModel
- //[DISP_PARAMS] = radius, fuzziness
- //[DESCRIPTION] =<text>
- //				scale: scale factor times volume fraction,
- //					or just volume fraction for absolute scale data
- //				radius: radius of the solid sphere
- //				fuzziness = the STD of the height of fuzzy interfacial
- //				 thickness (ie., so-called interfacial roughness)
- //				sldSph: the SLD of the sphere
- //				sldSolv: the SLD of the solvent
- //				background: incoherent background
- //			Note: By definition, this function works only when fuzziness << radius.
- //		</text>
- //[FIXED]=  radius.width; fuzziness.width
- //[ORIENTATION_PARAMS]= <text> </text>
+//[PYTHONCLASS] = FuzzySphereModel
+//[DISP_PARAMS] = radius, fuzziness
+//[DESCRIPTION] =<text>
+//				scale: scale factor times volume fraction,
+//					or just volume fraction for absolute scale data
+//				radius: radius of the solid sphere
+//				fuzziness = the STD of the height of fuzzy interfacial
+//				 thickness (ie., so-called interfacial roughness)
+//				sldSph: the SLD of the sphere
+//				sldSolv: the SLD of the solvent
+//				background: incoherent background
+//			Note: By definition, this function works only when fuzziness << radius.
+//		</text>
+//[FIXED]=  radius.width; fuzziness.width
+//[ORIENTATION_PARAMS]= <text> </text>
 
-typedef struct {
-    /// Scale factor
-    //  [DEFAULT]=scale= 0.01
-    double scale;
+class FuzzySphereModel{
+public:
+  // Model parameters
+  /// Radius of sphere [A]
+  //  [DEFAULT]=radius=60.0 [A]
+  Parameter radius;
+  /// Scale factor
+  //  [DEFAULT]=scale= 0.01
+  Parameter scale;
 
-    ///	Radius of sphere [A]
-    //  [DEFAULT]=radius=60.0 [A]
-    double radius;
 
-    ///	surface roughness [A]
-    //  [DEFAULT]=fuzziness= 10.0 [A]
-    double fuzziness;
+  /// surface roughness [A]
+  //  [DEFAULT]=fuzziness= 10.0 [A]
+  Parameter fuzziness;
 
-    ///	sldSph [1/A^(2)]
-    //  [DEFAULT]=sldSph= 1.0e-6 [1/A^(2)]
-    double sldSph;
+  /// sldSph [1/A^(2)]
+  //  [DEFAULT]=sldSph= 1.0e-6 [1/A^(2)]
+  Parameter sldSph;
 
-    ///	sldSolv [1/A^(2)]
-    //  [DEFAULT]=sldSolv= 3.0e-6 [1/A^(2)]
-    double sldSolv;
+  /// sldSolv [1/A^(2)]
+  //  [DEFAULT]=sldSolv= 3.0e-6 [1/A^(2)]
+  Parameter sldSolv;
 
-	/// Incoherent Background [1/cm]
-	//  [DEFAULT]=background=0.001 [1/cm]
-	double background;
-} FuzzySphereParameters;
+  /// Incoherent Background [1/cm]
+  //  [DEFAULT]=background=0.001 [1/cm]
+  Parameter background;
 
-/// kernel
-double fuzzysphere_kernel(double dp[], double q);
+  // Constructor
+  FuzzySphereModel();
 
-/// 1D scattering function
-double fuzzysphere_analytical_1D(FuzzySphereParameters *pars, double q);
+  // Operators to get I(Q)
+  double operator()(double q);
+  double operator()(double qx, double qy);
+  double calculate_ER();
+  double evaluate_rphi(double q, double phi);
+};
 
-/// 2D scattering function
-double fuzzysphere_analytical_2D(FuzzySphereParameters *pars, double q, double phi);
-double fuzzysphere_analytical_2DXY(FuzzySphereParameters *pars, double qx, double qy);
-double fuzzysphere_analytical_2D_scaled(FuzzySphereParameters *pars, double q, double q_x, double q_y);
 #endif
Index: sansmodels/src/c_extensions/pearlnecklace.h
===================================================================
--- sansmodels/src/c_extensions/pearlnecklace.h	(revision 67424cdc019bde2f4cbc089828ff660e6f914c2c)
+++ sansmodels/src/c_extensions/pearlnecklace.h	(revision 0ba3b08c35684feff124c0657dad569d13717a18)
@@ -1,66 +1,101 @@
 #if !defined(o_h)
 #define pearl_necklace_h
+#include "parameters.hh"
 
 /**
  * Structure definition for sphere parameters
  */
- //[PYTHONCLASS] = PearlNecklaceModel
- //[DISP_PARAMS] = radius, edge_separation
- //[DESCRIPTION] =<text>Calculate form factor for Pearl Necklace Model
+//[PYTHONCLASS] = PearlNecklaceModel
+//[DISP_PARAMS] = radius, edge_separation
+//[DESCRIPTION] =<text>Calculate form factor for Pearl Necklace Model
 //				[Macromol. Symp. 2004, 211, 25-42]
- //				Parameters:
- //				background:background
- //				scale: scale factor
- //				sld_pearl: the SLD of the pearl spheres
- //	            sld_string: the SLD of the strings
- //				sld_solv: the SLD of the solvent
- //				num_pearls: number of the pearls
- //				radius: the radius of a pearl
- //				edge_separation: the length of string segment; surface to surface
- //				thick_string: thickness (ie, diameter) of the string
- //		</text>
- //[FIXED]=  <text>radius.width; edge_separation.width</text>
- //[NON_FITTABLE_PARAMS]= <text></text>
- //[ORIENTATION_PARAMS]= <text> </text>
+//				Parameters:
+//				background:background
+//				scale: scale factor
+//				sld_pearl: the SLD of the pearl spheres
+//	            sld_string: the SLD of the strings
+//				sld_solv: the SLD of the solvent
+//				num_pearls: number of the pearls
+//				radius: the radius of a pearl
+//				edge_separation: the length of string segment; surface to surface
+//				thick_string: thickness (ie, diameter) of the string
+//		</text>
+//[FIXED]=  <text>radius.width; edge_separation.width</text>
+//[NON_FITTABLE_PARAMS]= <text></text>
+//[ORIENTATION_PARAMS]= <text> </text>
 
 typedef struct {
-    /// Scale factor
-    //  [DEFAULT]=scale= 1.0
-	double scale;
-    ///	radius [A]
-    //  [DEFAULT]=radius=80.0 [A]
-	double radius;
-	///	edge_separation
-	//  [DEFAULT]=edge_separation= 350 [A]
-	double edge_separation;
-	///	thick_string [A]
-	//  [DEFAULT]=thick_string= 2.5 [A]
-	double thick_string;
-	///	num_pearls
-	//  [DEFAULT]=num_pearls= 3
-	double num_pearls;
-	///	sld_pearl
-	//  [DEFAULT]=sld_pearl= 1.0e-06 [1/A^(2)]
-	double sld_pearl;
-	///	sld_string
-	//  [DEFAULT]=sld_string= 1.0e-06 [1/A^(2)]
-	double sld_string;
-	///	sld_solv
-	//  [DEFAULT]=sld_solv= 6.3e-06 [1/A^(2)]
-	double sld_solv;
-	/// Background
-	//  [DEFAULT]=background=0
-	double background;
+  /// Scale factor
+  //  [DEFAULT]=scale= 1.0
+  double scale;
+  ///	radius [A]
+  //  [DEFAULT]=radius=80.0 [A]
+  double radius;
+  ///	edge_separation
+  //  [DEFAULT]=edge_separation= 350 [A]
+  double edge_separation;
+  ///	thick_string [A]
+  //  [DEFAULT]=thick_string= 2.5 [A]
+  double thick_string;
+  ///	num_pearls
+  //  [DEFAULT]=num_pearls= 3
+  double num_pearls;
+  ///	sld_pearl
+  //  [DEFAULT]=sld_pearl= 1.0e-06 [1/A^(2)]
+  double sld_pearl;
+  ///	sld_string
+  //  [DEFAULT]=sld_string= 1.0e-06 [1/A^(2)]
+  double sld_string;
+  ///	sld_solv
+  //  [DEFAULT]=sld_solv= 6.3e-06 [1/A^(2)]
+  double sld_solv;
+  /// Background
+  //  [DEFAULT]=background=0
+  double background;
 
 }PeralNecklaceParameters;
 
-double pearl_necklace_kernel(double dq[], double q);
 
-/// 1D scattering function
-double pearl_necklace_analytical_1D(PeralNecklaceParameters *pars, double q);
 
-/// 2D scattering function
-double pearl_necklace_analytical_2D(PeralNecklaceParameters *pars, double q, double phi);
-double pearl_necklace_analytical_2DXY(PeralNecklaceParameters *pars, double qx, double qy);
+class PearlNecklaceModel{
+public:
+  // Model parameters
+  /// Scale factor
+  //  [DEFAULT]=scale= 1.0
+  Parameter scale;
+  /// radius [A]
+  //  [DEFAULT]=radius=80.0 [A]
+  Parameter radius;
+  /// edge_separation
+  //  [DEFAULT]=edge_separation= 350 [A]
+  Parameter edge_separation;
+  /// thick_string [A]
+  //  [DEFAULT]=thick_string= 2.5 [A]
+  Parameter thick_string;
+  /// num_pearls
+  //  [DEFAULT]=num_pearls= 3
+  Parameter num_pearls;
+  /// sld_pearl
+  //  [DEFAULT]=sld_pearl= 1.0e-06 [1/A^(2)]
+  Parameter sld_pearl;
+  /// sld_string
+  //  [DEFAULT]=sld_string= 1.0e-06 [1/A^(2)]
+  Parameter sld_string;
+  /// sld_solv
+  //  [DEFAULT]=sld_solv= 6.3e-06 [1/A^(2)]
+  Parameter sld_solv;
+  /// Background
+  //  [DEFAULT]=background=0
+  Parameter background;
+
+  // Constructor
+  PearlNecklaceModel();
+
+  // Operators to get I(Q)
+  double operator()(double q);
+  double operator()(double qx, double qy);
+  double calculate_ER();
+  double evaluate_rphi(double q, double phi);
+};
 
 #endif
